"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DomainTypeEnum: () => DomainTypeEnum,
  ProtocolEnum: () => ProtocolEnum,
  SpheronClient: () => SpheronClient,
  UploadStatusEnum: () => UploadStatusEnum,
  default: () => src_default,
  ipfs: () => ipfs
});
module.exports = __toCommonJS(src_exports);

// src/upload-manager/index.ts
var import_axios = __toESM(require("axios"));
var import_p_limit = __toESM(require("p-limit"));

// src/config/env/index.ts
var dotenv = __toESM(require("dotenv"));
dotenv.config();
var config2 = {
  spheronApiUrl: "https://api-v2.spheron.network"
};
var env_default = config2;

// src/enums.ts
var ProtocolEnum = /* @__PURE__ */ ((ProtocolEnum2) => {
  ProtocolEnum2["ARWEAVE"] = "arweave";
  ProtocolEnum2["FILECOIN"] = "ipfs-filecoin";
  ProtocolEnum2["IPFS"] = "ipfs";
  return ProtocolEnum2;
})(ProtocolEnum || {});

// src/upload-manager/upload-context.ts
var import_fs = __toESM(require("fs"));
var import_form_data = __toESM(require("form-data"));
var import_path = __toESM(require("path"));
var PayloadCreator = class {
  constructor(path2, payloadSize) {
    this.path = path2;
    this.payloadSize = payloadSize || 1024 * 1024 * 5;
  }
  createPayloads() {
    return __async(this, null, function* () {
      const uploadContext = {
        payloads: new Array(),
        currentPayload: null,
        currentPayloadSize: 0,
        totalSize: 0
      };
      yield this.fillUploadContext(this.path, "./", uploadContext, true);
      if (uploadContext.currentPayload) {
        uploadContext.payloads.push(uploadContext.currentPayload);
      }
      return {
        payloads: uploadContext.payloads,
        totalSize: uploadContext.totalSize
      };
    });
  }
  fillUploadContext(pathToFile, rootPath, uploadContext, isRoot) {
    return __async(this, null, function* () {
      const stat = yield import_fs.default.promises.stat(pathToFile);
      if (stat.isFile()) {
        const fileName = import_path.default.basename(pathToFile);
        this.processFile(pathToFile, rootPath + fileName, stat, uploadContext);
        return;
      }
      const files = yield import_fs.default.promises.readdir(pathToFile);
      for (const file of files) {
        yield this.fillUploadContext(
          `${pathToFile}/${file}`,
          isRoot ? "./" : `${rootPath}${import_path.default.basename(pathToFile)}/`,
          uploadContext,
          false
        );
      }
    });
  }
  processFile(fullPath, uploadPath, stat, uploadContext) {
    return __async(this, null, function* () {
      uploadContext.totalSize += stat.size;
      if (stat.size > this.payloadSize) {
        const numOfChunks = Math.ceil(stat.size / this.payloadSize);
        for (let i = 0; i < numOfChunks; i++) {
          const start = i * this.payloadSize;
          const end = start + this.payloadSize - 1;
          const form = new import_form_data.default();
          form.append(
            `chunk-${i}-${numOfChunks}`,
            import_fs.default.createReadStream(fullPath, { start, end }),
            {
              filepath: uploadPath
            }
          );
          uploadContext.payloads.push(form);
        }
      } else {
        if (!uploadContext.currentPayload) {
          uploadContext.currentPayload = new import_form_data.default();
        }
        uploadContext.currentPayload.append(
          "files",
          import_fs.default.createReadStream(fullPath),
          {
            filepath: uploadPath
          }
        );
        uploadContext.currentPayloadSize += stat.size;
        if (uploadContext.currentPayloadSize > this.payloadSize) {
          uploadContext.payloads.push(uploadContext.currentPayload);
          uploadContext.currentPayload = null;
          uploadContext.currentPayloadSize = 0;
        }
      }
    });
  }
};

// src/upload-manager/index.ts
var UploadManager = class {
  constructor(configuration) {
    this.configuration = configuration;
  }
  upload(configuration) {
    return __async(this, null, function* () {
      this.validateUploadConfiguration(configuration);
      const { deploymentId, payloadSize, parallelUploadCount } = yield this.startDeployment(
        configuration.protocol,
        configuration.name,
        configuration.organizationId
      );
      configuration.onUploadInitiated && configuration.onUploadInitiated(deploymentId);
      const payloadCreator = new PayloadCreator(configuration.path, payloadSize);
      const { payloads, totalSize } = yield payloadCreator.createPayloads();
      const uploadPayloadsResult = yield this.uploadPayloads(
        deploymentId,
        payloads,
        parallelUploadCount,
        totalSize,
        configuration.onChunkUploaded
      );
      const result = yield this.finalizeUploadDeployment(
        deploymentId,
        uploadPayloadsResult.success
      );
      if (!result.success) {
        throw new Error(`Upload failed. ${result.message}`);
      }
      return {
        uploadId: result.deploymentId,
        bucketId: result.projectId,
        protocolLink: result.sitePreview,
        dynamicLinks: result.affectedDomains
      };
    });
  }
  startDeployment(protocol, projectName, organizationId) {
    return __async(this, null, function* () {
      var _a, _b;
      try {
        let url = `${env_default.spheronApiUrl}/v1/upload-deployment?protocol=${protocol}&project=${projectName}`;
        if (organizationId) {
          url += `&organization=${organizationId}`;
        }
        const response = yield import_axios.default.post(url, {}, this.getAxiosRequestConfig());
        return response.data;
      } catch (error) {
        const errorMessage = ((_b = (_a = error == null ? void 0 : error.response) == null ? void 0 : _a.data) == null ? void 0 : _b.message) || (error == null ? void 0 : error.message);
        throw new Error(errorMessage);
      }
    });
  }
  uploadPayloads(deploymentId, payloads, parallelUploadCount, totalSize, onChunkUploaded) {
    return __async(this, null, function* () {
      let errorFlag = false;
      const limit = (0, import_p_limit.default)(parallelUploadCount);
      const uploadPayload = (payload, deploymentId2) => __async(this, null, function* () {
        try {
          if (errorFlag) {
            return;
          }
          const { data } = yield import_axios.default.post(
            `${env_default.spheronApiUrl}/v1/upload-deployment/${deploymentId2}/data`,
            payload,
            this.getAxiosRequestConfig()
          );
          onChunkUploaded && onChunkUploaded(data.uploadSize, totalSize);
        } catch (error) {
          errorFlag = true;
        }
      });
      yield Promise.all(
        payloads.map(
          (payload) => limit(() => uploadPayload(payload, deploymentId))
        )
      );
      return { success: !errorFlag };
    });
  }
  finalizeUploadDeployment(deploymentId, upload) {
    return __async(this, null, function* () {
      var _a, _b;
      try {
        const response = yield import_axios.default.post(
          `${env_default.spheronApiUrl}/v1/upload-deployment/${deploymentId}/finish?action=${upload ? "UPLOAD" : "CANCEL"}`,
          {},
          this.getAxiosRequestConfig()
        );
        return response.data;
      } catch (error) {
        const errorMessage = ((_b = (_a = error == null ? void 0 : error.response) == null ? void 0 : _a.data) == null ? void 0 : _b.message) || (error == null ? void 0 : error.message);
        throw new Error(errorMessage);
      }
    });
  }
  validateUploadConfiguration(configuration) {
    const supportedProtocols = Object.values(ProtocolEnum);
    if (supportedProtocols.indexOf(configuration.protocol) === -1) {
      throw new Error(
        `Protocol '${configuration.protocol}' is not supported. Supported protocols are [${supportedProtocols.join(
          ", "
        )}].`
      );
    }
    if (!configuration.name) {
      throw new Error("Name is not provided.");
    }
  }
  getAxiosRequestConfig() {
    return {
      headers: {
        Authorization: `Bearer ${this.configuration.token}`
      }
    };
  }
};
var upload_manager_default = UploadManager;

// src/spheron-api/index.ts
var import_axios2 = __toESM(require("axios"));
var SpheronApi = class {
  constructor(token) {
    this.token = token;
  }
  getTokenScope() {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Get" /* GET */,
        "/v1/api-keys/scope"
      );
    });
  }
  getProject(projectId) {
    return __async(this, null, function* () {
      return this.sendApiRequest(
        "Get" /* GET */,
        `/v1/project/${projectId}`
      );
    });
  }
  getProjectDeployments(projectId, options) {
    return __async(this, null, function* () {
      if (options.skip < 0 || options.limit < 0) {
        throw new Error(`Skip and Limit cannot be negative numbers.`);
      }
      const deployments = yield this.sendApiRequest(
        "Get" /* GET */,
        `/v1/project/${projectId}/deployments?skip=${options.skip}&limit=${options.limit}${options.status ? `&status=${options.status}` : ""}`
      );
      return { deployments };
    });
  }
  getProjectDomains(projectId) {
    return __async(this, null, function* () {
      return this.sendApiRequest(
        "Get" /* GET */,
        `/v1/project/${projectId}/domains`
      );
    });
  }
  getProjectDomain(projectId, domainIdentifier) {
    return __async(this, null, function* () {
      return this.sendApiRequest(
        "Get" /* GET */,
        `/v1/project/${projectId}/domains/${domainIdentifier}`
      );
    });
  }
  addProjectDomain(projectId, options) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Post" /* POST */,
        `/v1/project/${projectId}/domains`,
        options
      );
    });
  }
  patchProjectDomain(projectId, domainIdentifier, options) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Patch" /* PATCH */,
        `/v1/project/${projectId}/domains/${domainIdentifier}`,
        options
      );
    });
  }
  verifyProjectDomain(projectId, domainIdentifier) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Patch" /* PATCH */,
        `/v1/project/${projectId}/domains/${domainIdentifier}/verify`,
        {}
      );
    });
  }
  deleteProjectDomain(projectId, domainIdentifier) {
    return __async(this, null, function* () {
      yield this.sendApiRequest(
        "Delete" /* DELETE */,
        `/v1/project/${projectId}/domains/${domainIdentifier}`
      );
    });
  }
  getProjectDeploymentCount(projectId) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest("Get" /* GET */, `/v1/project/${projectId}/deployments/count`);
    });
  }
  updateProjectState(projectId, state) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Patch" /* PATCH */,
        `/v1/project/${projectId}/state`,
        { state }
      );
    });
  }
  updateProjectConfiguration(projectId, options) {
    return __async(this, null, function* () {
      return yield this.sendApiRequest(
        "Put" /* PUT */,
        `/v1/project/${projectId}/configuration`,
        options
      );
    });
  }
  getDeployment(deploymentId) {
    return __async(this, null, function* () {
      const { deployment } = yield this.sendApiRequest("Get" /* GET */, `/v1/deployment/${deploymentId}`);
      return deployment;
    });
  }
  getOrganizationUsage(organizationId, specialization) {
    return __async(this, null, function* () {
      const { usage } = yield this.sendApiRequest(
        "Get" /* GET */,
        `/v1/organization/${organizationId}/subscription-usage/specialization/${specialization}`
      );
      return usage;
    });
  }
  publishIPNS(deploymentId) {
    return __async(this, null, function* () {
      const resp = yield this.sendApiRequest(
        "Post" /* POST */,
        `/v1/ipns/deployments/${deploymentId}/names`
      );
      return this.mapIPNSResponseToIPNSName(resp.ipnsName);
    });
  }
  updateIPNSName(ipnsNameId, deploymentId) {
    return __async(this, null, function* () {
      const resp = yield this.sendApiRequest(
        "Put" /* PUT */,
        `/v1/ipns/deployments/${deploymentId}/names/${ipnsNameId}`
      );
      return this.mapIPNSResponseToIPNSName(resp.ipnsName);
    });
  }
  getIPNSName(ipnsNameId) {
    return __async(this, null, function* () {
      const resp = yield this.sendApiRequest(
        "Get" /* GET */,
        `/v1/ipns/names/${ipnsNameId}`
      );
      return this.mapIPNSResponseToIPNSName(resp);
    });
  }
  getIPNSNamesForUpload(uploadId) {
    return __async(this, null, function* () {
      const resp = yield this.sendApiRequest(
        "Get" /* GET */,
        `/v1/ipns/deployments/${uploadId}/names`
      );
      return resp.map((ipnsName) => this.mapIPNSResponseToIPNSName(ipnsName));
    });
  }
  getIPNSNamesForOrganization(organizationId) {
    return __async(this, null, function* () {
      const resp = yield this.sendApiRequest(
        "Get" /* GET */,
        `/v1/ipns/names`,
        {
          organizationId
        }
      );
      return resp.map((ipnsName) => this.mapIPNSResponseToIPNSName(ipnsName));
    });
  }
  sendApiRequest(method, path2, payload) {
    return __async(this, null, function* () {
      var _a, _b;
      try {
        const response = yield (0, import_axios2.default)({
          method,
          url: `${env_default.spheronApiUrl}${path2}`,
          data: payload,
          headers: {
            Authorization: `Bearer ${this.token}`
          }
        });
        return response.data;
      } catch (error) {
        throw new Error(((_b = (_a = error.response) == null ? void 0 : _a.data) == null ? void 0 : _b.message) || (error == null ? void 0 : error.message));
      }
    });
  }
  mapIPNSResponseToIPNSName(ipnsResponse) {
    return {
      id: ipnsResponse._id,
      publishedUploadId: ipnsResponse.publishedDeploymentId,
      organizationId: ipnsResponse.organizationId,
      createdAt: ipnsResponse.createdAt,
      updatedAt: ipnsResponse.updatedAt,
      ipnsHash: ipnsResponse.keyId,
      ipnsLink: ipnsResponse.ipnsLink
    };
  }
};
var spheron_api_default = SpheronApi;

// src/spheron-api/enums.ts
var DomainTypeEnum = /* @__PURE__ */ ((DomainTypeEnum2) => {
  DomainTypeEnum2["DOMAIN"] = "domain";
  DomainTypeEnum2["SUBDOMAIN"] = "subdomain";
  DomainTypeEnum2["HANDSHAKE_DOMAIN"] = "handshake-domain";
  DomainTypeEnum2["HANDSHAKE_SUBDOMAIN"] = "handshake-subdomain";
  DomainTypeEnum2["ENS_DOMAIN"] = "ens-domain";
  return DomainTypeEnum2;
})(DomainTypeEnum || {});

// src/bucket-manager/interfaces.ts
var UploadStatusEnum = /* @__PURE__ */ ((UploadStatusEnum2) => {
  UploadStatusEnum2["PENDING"] = "Pending";
  UploadStatusEnum2["CANCELED"] = "Canceled";
  UploadStatusEnum2["DEPLOYED"] = "Deployed";
  UploadStatusEnum2["FAILED"] = "Failed";
  UploadStatusEnum2["TIMED_OUT"] = "TimedOut";
  return UploadStatusEnum2;
})(UploadStatusEnum || {});

// src/bucket-manager/index.ts
var BucketManager = class {
  constructor(spheronApi) {
    this.spheronApi = spheronApi;
  }
  getBucket(bucketId) {
    return __async(this, null, function* () {
      const project = yield this.spheronApi.getProject(bucketId);
      if (project.type !== "UPLOAD" /* UPLOAD */) {
        throw new Error(`Project with id '${bucketId}' is not a bucket.`);
      }
      return this.mapProjectToBucket(project);
    });
  }
  getBucketDomains(bucketId) {
    return __async(this, null, function* () {
      const { domains } = yield this.spheronApi.getProjectDomains(bucketId);
      return domains.map((x) => this.mapProjectDomainToBucketDomain(x));
    });
  }
  getBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      const { domain } = yield this.spheronApi.getProjectDomain(
        bucketId,
        domainIdentifier
      );
      return this.mapProjectDomainToBucketDomain(domain);
    });
  }
  updateBucketDomain(bucketId, domainIdentifier, options) {
    return __async(this, null, function* () {
      const { domain } = yield this.spheronApi.patchProjectDomain(
        bucketId,
        domainIdentifier,
        __spreadProps(__spreadValues({}, options), { deploymentEnvironments: [] })
      );
      return this.mapProjectDomainToBucketDomain(domain);
    });
  }
  verifyBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      const { domain } = yield this.spheronApi.verifyProjectDomain(
        bucketId,
        domainIdentifier
      );
      return this.mapProjectDomainToBucketDomain(domain);
    });
  }
  deleteBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      yield this.spheronApi.deleteProjectDomain(bucketId, domainIdentifier);
    });
  }
  addBucketDomain(bucketId, options) {
    return __async(this, null, function* () {
      const { domain } = yield this.spheronApi.addProjectDomain(bucketId, __spreadProps(__spreadValues({}, options), {
        deploymentEnvironments: []
      }));
      return this.mapProjectDomainToBucketDomain(domain);
    });
  }
  getBucketUploads(bucketId, options) {
    return __async(this, null, function* () {
      if (options.skip < 0 || options.limit < 0) {
        throw new Error(`Skip and Limit cannot be negative numbers.`);
      }
      const { deployments } = yield this.spheronApi.getProjectDeployments(
        bucketId,
        {
          skip: options.skip && options.skip >= 0 ? options.skip : 0,
          limit: options.limit && options.limit >= 0 ? options.limit : 6
        }
      );
      return deployments.map((x) => this.mapDeploymentToUpload(x));
    });
  }
  getBucketUploadCount(bucketId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.getProjectDeploymentCount(bucketId);
    });
  }
  archiveBucket(bucketId) {
    return __async(this, null, function* () {
      yield this.spheronApi.updateProjectState(
        bucketId,
        "ARCHIVED" /* ARCHIVED */
      );
    });
  }
  unarchiveBucket(bucketId) {
    return __async(this, null, function* () {
      yield this.spheronApi.updateProjectState(
        bucketId,
        "MAINTAINED" /* MAINTAINED */
      );
    });
  }
  getUpload(uploadId) {
    return __async(this, null, function* () {
      const deployment = yield this.spheronApi.getDeployment(uploadId);
      return this.mapDeploymentToUpload(deployment);
    });
  }
  mapProjectToBucket(project) {
    var _a;
    return {
      id: project._id,
      name: project.name,
      organizationId: project.organization,
      state: project.state,
      domains: (_a = project.domains) == null ? void 0 : _a.map(
        (x) => this.mapProjectDomainToBucketDomain(x)
      )
    };
  }
  mapProjectDomainToBucketDomain(domain) {
    return {
      id: domain._id,
      name: domain.name,
      link: domain.link,
      verified: domain.verified,
      bucketId: domain.projectId,
      type: domain.type
    };
  }
  mapDeploymentToUpload(deployment) {
    var _a, _b;
    return {
      id: deployment._id,
      protocolLink: deployment.sitePreview,
      buildDirectory: deployment.buildDirectory,
      status: deployment.status,
      memoryUsed: deployment.memoryUsed,
      bucketId: (_b = (_a = deployment.project) == null ? void 0 : _a._id) != null ? _b : deployment.project,
      protocol: deployment.protocol
    };
  }
};
var bucket_manager_default = BucketManager;

// src/ipfs.utils.ts
var import_cid = require("multiformats/cid");
var ipfs = {
  utils: {
    toV0: (v1) => {
      const cid = import_cid.CID.parse(v1);
      if (cid.version === 0)
        return v1;
      return cid.toV0().toString();
    },
    toV1: (v0) => {
      const cid = import_cid.CID.parse(v0);
      if (cid.version === 1)
        return v0;
      return cid.toV1().toString();
    }
  }
};

// src/index.ts
var SpheronClient = class {
  constructor(configuration) {
    this.configuration = configuration;
    this.spheronApi = new spheron_api_default(this.configuration.token);
    this.bucketManager = new bucket_manager_default(this.spheronApi);
    this.uploadManager = new upload_manager_default(this.configuration);
  }
  upload(path2, configuration) {
    return __async(this, null, function* () {
      return yield this.uploadManager.upload({
        path: path2,
        name: configuration.name,
        protocol: configuration.protocol,
        organizationId: configuration.organizationId,
        onChunkUploaded: configuration.onChunkUploaded,
        onUploadInitiated: configuration.onUploadInitiated
      });
    });
  }
  getBucket(bucketId) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getBucket(bucketId);
    });
  }
  getBucketDomains(bucketId) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getBucketDomains(bucketId);
    });
  }
  getBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getBucketDomain(bucketId, domainIdentifier);
    });
  }
  addBucketDomain(bucketId, options) {
    return __async(this, null, function* () {
      return yield this.bucketManager.addBucketDomain(bucketId, options);
    });
  }
  updateBucketDomain(bucketId, domainIdentifier, options) {
    return __async(this, null, function* () {
      return yield this.bucketManager.updateBucketDomain(
        bucketId,
        domainIdentifier,
        options
      );
    });
  }
  verifyBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      return yield this.bucketManager.verifyBucketDomain(
        bucketId,
        domainIdentifier
      );
    });
  }
  deleteBucketDomain(bucketId, domainIdentifier) {
    return __async(this, null, function* () {
      return yield this.bucketManager.deleteBucketDomain(
        bucketId,
        domainIdentifier
      );
    });
  }
  archiveBucket(bucketId) {
    return __async(this, null, function* () {
      yield this.bucketManager.archiveBucket(bucketId);
    });
  }
  unarchiveBucket(bucketId) {
    return __async(this, null, function* () {
      yield this.bucketManager.unarchiveBucket(bucketId);
    });
  }
  publishIPNS(uploadId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.publishIPNS(uploadId);
    });
  }
  updateIPNSName(ipnsNameId, uploadId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.updateIPNSName(ipnsNameId, uploadId);
    });
  }
  getIPNSName(ipnsNameId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.getIPNSName(ipnsNameId);
    });
  }
  getIPNSNamesForUpload(uploadId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.getIPNSNamesForUpload(uploadId);
    });
  }
  getIPNSNamesForOrganization(organizationId) {
    return __async(this, null, function* () {
      return yield this.spheronApi.getIPNSNamesForOrganization(organizationId);
    });
  }
  getBucketUploadCount(bucketId) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getBucketUploadCount(bucketId);
    });
  }
  getBucketUploads(bucketId, options) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getBucketUploads(bucketId, options);
    });
  }
  getUpload(uploadId) {
    return __async(this, null, function* () {
      return yield this.bucketManager.getUpload(uploadId);
    });
  }
  getOrganizationUsage(organizationId) {
    return __async(this, null, function* () {
      const usage = yield this.spheronApi.getOrganizationUsage(
        organizationId,
        "wa-global"
      );
      const _a = usage, { usedStorageSkynet, storageSkynetLimit } = _a, resultWithoutSkynet = __objRest(_a, ["usedStorageSkynet", "storageSkynetLimit"]);
      return resultWithoutSkynet;
    });
  }
  getTokenScope() {
    return __async(this, null, function* () {
      return yield this.spheronApi.getTokenScope();
    });
  }
};
var src_default = SpheronClient;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DomainTypeEnum,
  ProtocolEnum,
  SpheronClient,
  UploadStatusEnum,
  ipfs
});
